<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include(get_language_filepath('plugin.lang.php', AUTOUPDATE_PATH));
include(AUTOUPDATE_PATH.'include/functions.inc.php');
include(AUTOUPDATE_PATH.'include/pclzip.lib.php');

$conf['local_data_dir'] = dirname(dirname(dirname(__FILE__))).'/_data';

/*
STEP:
0 = check is needed. If version is latest or check fail, we stay on step 0
1 = new version on same branch AND new branch are available => user may choose upgrade.
2 = upgrade on same branch
3 = upgrade on different branch
*/
$step = isset($_GET['step']) ? $_GET['step'] : 0;
$upgrade_to = isset($_GET['to']) ? $_GET['to'] : '';

// +-----------------------------------------------------------------------+
// |                                Step 0                                 |
// +-----------------------------------------------------------------------+
if ($step == 0)
{
  if (preg_match('/(\d+\.\d+)\.(\d+)/', PHPWG_VERSION, $matches))
  {
    $url = 'http://piwigo.org/download/all_versions.php';
    $url .= '?rand='.md5(uniqid(rand(), true)); // Avoid server cache

    if (@fetchRemote($url, $result)
      and $all_versions = @explode("\n", $result)
      and is_array($all_versions))
    {
      $last_version = trim($all_versions[0]);
      $upgrade_to = $last_version;

      if (version_compare(PHPWG_VERSION, $last_version, '<'))
      {
        $new_branch = preg_replace('/(\d+\.\d+)\.\d+/', '$1', $last_version);
        $actual_branch = $matches[1];

        if ($new_branch == $actual_branch)
        {
          $step = 2;
        }
        else
        {
          $step = 3;

          // Check if new version exists in same branch
          foreach ($all_versions as $version)
          {
            $new_branch = preg_replace('/(\d+\.\d+)\.\d+/', '$1', $version);

            if ($new_branch == $actual_branch)
            {
              if (version_compare(PHPWG_VERSION, $version, '<'))
              {
                $step = 1;
              }
              break;
            }
          }
        }
      }
    }
  }
}

// +-----------------------------------------------------------------------+
// |                                Step 1                                 |
// +-----------------------------------------------------------------------+
if ($step == 1)
{
  $template->assign_vars(array(
    'MINOR_VERSION' => $version,
    'MAJOR_VERSION' => $last_version,
    'UPGRADE_TO_MINOR_VERSION' => sprintf(l10n('Upgrade to Piwigo %s'), $version),
    'UPGRADE_TO_MAJOR_VERSION' => sprintf(l10n('Upgrade to Piwigo %s'), $last_version),
    'UPGRADE_DESC' => sprintf(l10n('You can upgrade to Piwigo %s directly, without upgrading to Piwigo %s (recommended).'), $last_version, $version),
    )
  );
}

// +-----------------------------------------------------------------------+
// |                                Step 2                                 |
// +-----------------------------------------------------------------------+
if ($step == 2 and is_webmaster())
{
  if (isset($_POST['submit']) and isset($_POST['upgrade_to']))
  {
    autoupdate_upgrade_to($_POST['upgrade_to'], $step);
  }
}

// +-----------------------------------------------------------------------+
// |                                Step 3                                 |
// +-----------------------------------------------------------------------+
if ($step == 3 and is_webmaster())
{
  if (isset($_POST['saveTemplate']) and version_compare(PHPWG_VERSION, '2.1', '<'))
  {
    autoupdate_save_template_dir();
  }

  if (isset($_POST['dumpDatabase']))
  {
    autoupdate_dump_database();
  }

  if (isset($_POST['submit']) and isset($_POST['upgrade_to']))
  {
    autoupdate_upgrade_to($_POST['upgrade_to'], $step);
  }
}

// +-----------------------------------------------------------------------+
// |                        Process template                               |
// +-----------------------------------------------------------------------+

if (!is_webmaster())
{
  array_push($page['errors'], l10n('Webmaster status is required.'));
}

$template->assign_vars(array(
  'AU_URL'         => get_admin_plugin_menu_link(AUTOUPDATE_PATH . '/autoupdate.php'),
  'UPGRADE_TO'     => $upgrade_to,
  'UPGRADE_TO_VER' => sprintf(l10n('Upgrade to Piwigo %s'), $upgrade_to),
  'MINOR_UPGRADE_DESC' => l10n('This is a minor upgrade, with only bug corrections.'),
  'MAJOR_UPGRADE_DESC' => sprintf(l10n('This is a major upgrade, with <a href="%s">new exciting features</a>.'), 'http://piwigo.org/releases/'.$upgrade_to),
  'RELEASE_URL'    => PHPWG_URL.'/releases/'.$upgrade_to,
  )
);

$template->assign_block_vars('step_'.$step, array());

$template->set_filename('plugin_admin_content', AUTOUPDATE_PATH.'template/autoupdate.tpl');
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>